diff --git a/src/backend/access/index/amvalidate.c b/src/backend/access/index/amvalidate.c
index d13054e33f..89b5ade49a 100644
--- a/src/backend/access/index/amvalidate.c
+++ b/src/backend/access/index/amvalidate.c
@@ -62,14 +62,14 @@ identify_opfamily_groups(CatCList *oprlist, CatCList *proclist)
 	io = ip = 0;
 	if (io < oprlist->n_members)
 	{
-		oprform = (Form_pg_amop) GETSTRUCT(&oprlist->members[io]->tuple);
+		oprform = GETSTRUCT(pg_amop, &oprlist->members[io]->tuple);
 		io++;
 	}
 	else
 		oprform = NULL;
 	if (ip < proclist->n_members)
 	{
-		procform = (Form_pg_amproc) GETSTRUCT(&proclist->members[ip]->tuple);
+		procform = GETSTRUCT(pg_amproc, &proclist->members[ip]->tuple);
 		ip++;
 	}
 	else
@@ -89,7 +89,7 @@ identify_opfamily_groups(CatCList *oprlist, CatCList *proclist)
 
 			if (io < oprlist->n_members)
 			{
-				oprform = (Form_pg_amop) GETSTRUCT(&oprlist->members[io]->tuple);
+				oprform = GETSTRUCT(pg_amop, &oprlist->members[io]->tuple);
 				io++;
 			}
 			else
@@ -109,7 +109,7 @@ identify_opfamily_groups(CatCList *oprlist, CatCList *proclist)
 
 			if (ip < proclist->n_members)
 			{
-				procform = (Form_pg_amproc) GETSTRUCT(&proclist->members[ip]->tuple);
+				procform = GETSTRUCT(pg_amproc, &proclist->members[ip]->tuple);
 				ip++;
 			}
 			else
@@ -161,7 +161,7 @@ check_amproc_signature(Oid funcid, Oid restype, bool exact,
 	tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(tp);
+	procform = GETSTRUCT(pg_proc, tp);
 
 	if (procform->prorettype != restype || procform->proretset ||
 		procform->pronargs < minargs || procform->pronargs > maxargs)
@@ -212,7 +212,7 @@ check_amop_signature(Oid opno, Oid restype, Oid lefttype, Oid righttype)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (!HeapTupleIsValid(tp))	/* shouldn't happen */
 		elog(ERROR, "cache lookup failed for operator %u", opno);
-	opform = (Form_pg_operator) GETSTRUCT(tp);
+	opform = GETSTRUCT(pg_operator, tp);
 
 	if (opform->oprresult != restype || opform->oprkind != 'b' ||
 		opform->oprleft != lefttype || opform->oprright != righttype)
@@ -249,7 +249,7 @@ opclass_for_family_datatype(Oid amoid, Oid opfamilyoid, Oid datatypeoid)
 	for (i = 0; i < opclist->n_members; i++)
 	{
 		HeapTuple	classtup = &opclist->members[i]->tuple;
-		Form_pg_opclass classform = (Form_pg_opclass) GETSTRUCT(classtup);
+		Form_pg_opclass classform = GETSTRUCT(pg_opclass, classtup);
 
 		if (classform->opcfamily == opfamilyoid &&
 			classform->opcintype == datatypeoid)
diff --git a/src/backend/access/nbtree/nbtvalidate.c b/src/backend/access/nbtree/nbtvalidate.c
index 55ed3251d3..05d3c6707e 100644
--- a/src/backend/access/nbtree/nbtvalidate.c
+++ b/src/backend/access/nbtree/nbtvalidate.c
@@ -62,7 +62,7 @@ btvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -72,7 +72,7 @@ btvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -84,7 +84,7 @@ btvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 		bool		ok;
 
 		/* Check procedure numbers and function signatures */
@@ -141,7 +141,7 @@ btvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 
 		/* Check that only allowed strategy numbers exist */
 		if (oprform->amopstrategy < 1 ||
diff --git a/src/backend/access/spgist/spgutils.c b/src/backend/access/spgist/spgutils.c
index 2c661fcf96..93ed425c29 100644
--- a/src/backend/access/spgist/spgutils.c
+++ b/src/backend/access/spgist/spgutils.c
@@ -163,7 +163,7 @@ fillTypeDesc(SpGistTypeDesc *desc, Oid type)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for type %u", type);
-	typtup = (Form_pg_type) GETSTRUCT(tp);
+	typtup = GETSTRUCT(pg_type, tp);
 	desc->attlen = typtup->typlen;
 	desc->attbyval = typtup->typbyval;
 	desc->attalign = typtup->typalign;
@@ -1328,7 +1328,7 @@ spgproperty(Oid index_oid, int attno,
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	amoptup = &catlist->members[i]->tuple;
-		Form_pg_amop amopform = (Form_pg_amop) GETSTRUCT(amoptup);
+		Form_pg_amop amopform = GETSTRUCT(pg_amop, amoptup);
 
 		if (amopform->amoppurpose == AMOP_ORDER &&
 			(amopform->amoplefttype == opcintype ||
diff --git a/src/backend/access/spgist/spgvalidate.c b/src/backend/access/spgist/spgvalidate.c
index 82281f7b83..ab055f9371 100644
--- a/src/backend/access/spgist/spgvalidate.c
+++ b/src/backend/access/spgist/spgvalidate.c
@@ -64,7 +64,7 @@ spgvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -75,7 +75,7 @@ spgvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -88,7 +88,7 @@ spgvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 		bool		ok;
 
 		/*
@@ -210,7 +210,7 @@ spgvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 		Oid			op_rettype;
 
 		/* TODO: Check that only allowed strategy numbers exist */
diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
index 088556ab54..3a718201f3 100644
--- a/src/backend/bootstrap/bootstrap.c
+++ b/src/backend/bootstrap/bootstrap.c
@@ -720,7 +720,7 @@ populate_typ_list(void)
 	old = MemoryContextSwitchTo(TopMemoryContext);
 	while ((tup = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_type typForm = (Form_pg_type) GETSTRUCT(tup);
+		Form_pg_type typForm = GETSTRUCT(pg_type, tup);
 		struct typmap *newtyp;
 
 		newtyp = (struct typmap *) palloc(sizeof(struct typmap));
diff --git a/src/backend/catalog/aclchk.c b/src/backend/catalog/aclchk.c
index 5f1726c095..913fdbbea0 100644
--- a/src/backend/catalog/aclchk.c
+++ b/src/backend/catalog/aclchk.c
@@ -884,7 +884,7 @@ objectsInSchemaToOids(ObjectType objtype, List *nspnames)
 
 					while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 					{
-						Oid			oid = ((Form_pg_proc) GETSTRUCT(tuple))->oid;
+						Oid			oid = (GETSTRUCT(pg_proc, tuple))->oid;
 
 						objects = lappend_oid(objects, oid);
 					}
@@ -931,7 +931,7 @@ getRelationsInNamespace(Oid namespaceId, char relkind)
 
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Oid			oid = ((Form_pg_class) GETSTRUCT(tuple))->oid;
+		Oid			oid = (GETSTRUCT(pg_class, tuple))->oid;
 
 		relations = lappend_oid(relations, oid);
 	}
@@ -1333,7 +1333,7 @@ SetDefaultACL(InternalDefaultACL *iacls)
 			 * there shouldn't be anything depending on this entry.
 			 */
 			myself.classId = DefaultAclRelationId;
-			myself.objectId = ((Form_pg_default_acl) GETSTRUCT(tuple))->oid;
+			myself.objectId = (GETSTRUCT(pg_default_acl, tuple))->oid;
 			myself.objectSubId = 0;
 
 			performDeletion(&myself, DROP_RESTRICT, 0);
@@ -1364,7 +1364,7 @@ SetDefaultACL(InternalDefaultACL *iacls)
 		}
 		else
 		{
-			defAclOid = ((Form_pg_default_acl) GETSTRUCT(tuple))->oid;
+			defAclOid = (GETSTRUCT(pg_default_acl, tuple))->oid;
 
 			/* update existing entry */
 			values[Anum_pg_default_acl_defaclacl - 1] = PointerGetDatum(new_acl);
@@ -1460,7 +1460,7 @@ RemoveRoleFromObjectACL(Oid roleid, Oid classid, Oid objid)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "could not find tuple for default ACL %u", objid);
 
-		pg_default_acl_tuple = (Form_pg_default_acl) GETSTRUCT(tuple);
+		pg_default_acl_tuple = GETSTRUCT(pg_default_acl, tuple);
 
 		iacls.roleid = pg_default_acl_tuple->defaclrole;
 		iacls.nspid = pg_default_acl_tuple->defaclnamespace;
@@ -1630,7 +1630,7 @@ expand_all_col_privileges(Oid table_oid, Form_pg_class classForm,
 			elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 				 curr_att, table_oid);
 
-		isdropped = ((Form_pg_attribute) GETSTRUCT(attTuple))->attisdropped;
+		isdropped = (GETSTRUCT(pg_attribute, attTuple))->attisdropped;
 
 		ReleaseSysCache(attTuple);
 
@@ -1676,7 +1676,7 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 	if (!HeapTupleIsValid(attr_tuple))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, relOid);
-	pg_attribute_tuple = (Form_pg_attribute) GETSTRUCT(attr_tuple);
+	pg_attribute_tuple = GETSTRUCT(pg_attribute, attr_tuple);
 
 	/*
 	 * Get working copy of existing ACL. If there's no ACL, substitute the
@@ -1825,7 +1825,7 @@ ExecGrant_Relation(InternalGrant *istmt)
 		tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relOid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for relation %u", relOid);
-		pg_class_tuple = (Form_pg_class) GETSTRUCT(tuple);
+		pg_class_tuple = GETSTRUCT(pg_class, tuple);
 
 		/* Not sensible to grant on an index */
 		if (pg_class_tuple->relkind == RELKIND_INDEX ||
@@ -2163,7 +2163,7 @@ ExecGrant_Database(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for database %u", datId);
 
-		pg_database_tuple = (Form_pg_database) GETSTRUCT(tuple);
+		pg_database_tuple = GETSTRUCT(pg_database, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -2284,7 +2284,7 @@ ExecGrant_Fdw(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for foreign-data wrapper %u", fdwid);
 
-		pg_fdw_tuple = (Form_pg_foreign_data_wrapper) GETSTRUCT(tuple);
+		pg_fdw_tuple = GETSTRUCT(pg_foreign_data_wrapper, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -2410,7 +2410,7 @@ ExecGrant_ForeignServer(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for foreign server %u", srvid);
 
-		pg_server_tuple = (Form_pg_foreign_server) GETSTRUCT(tuple);
+		pg_server_tuple = GETSTRUCT(pg_foreign_server, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -2535,7 +2535,7 @@ ExecGrant_Function(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for function %u", funcId);
 
-		pg_proc_tuple = (Form_pg_proc) GETSTRUCT(tuple);
+		pg_proc_tuple = GETSTRUCT(pg_proc, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -2658,7 +2658,7 @@ ExecGrant_Language(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for language %u", langId);
 
-		pg_language_tuple = (Form_pg_language) GETSTRUCT(tuple);
+		pg_language_tuple = GETSTRUCT(pg_language, tuple);
 
 		if (!pg_language_tuple->lanpltrusted)
 			ereport(ERROR,
@@ -2803,7 +2803,7 @@ ExecGrant_Largeobject(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "could not find tuple for large object %u", loid);
 
-		form_lo_meta = (Form_pg_largeobject_metadata) GETSTRUCT(tuple);
+		form_lo_meta = GETSTRUCT(pg_largeobject_metadata, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -2929,7 +2929,7 @@ ExecGrant_Namespace(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for namespace %u", nspid);
 
-		pg_namespace_tuple = (Form_pg_namespace) GETSTRUCT(tuple);
+		pg_namespace_tuple = GETSTRUCT(pg_namespace, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -3054,7 +3054,7 @@ ExecGrant_Tablespace(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for tablespace %u", tblId);
 
-		pg_tablespace_tuple = (Form_pg_tablespace) GETSTRUCT(tuple);
+		pg_tablespace_tuple = GETSTRUCT(pg_tablespace, tuple);
 
 		/*
 		 * Get owner ID and working copy of existing ACL. If there's no ACL,
@@ -3174,7 +3174,7 @@ ExecGrant_Type(InternalGrant *istmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for type %u", typId);
 
-		pg_type_tuple = (Form_pg_type) GETSTRUCT(tuple);
+		pg_type_tuple = GETSTRUCT(pg_type, tuple);
 
 		if (IsTrueArrayType(pg_type_tuple))
 			ereport(ERROR,
@@ -3958,7 +3958,7 @@ pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum, Oid roleid,
 							attnum, table_oid)));
 	}
 
-	attributeForm = (Form_pg_attribute) GETSTRUCT(attTuple);
+	attributeForm = GETSTRUCT(pg_attribute, attTuple);
 
 	/* Check dropped columns, too */
 	if (attributeForm->attisdropped)
@@ -4005,7 +4005,7 @@ pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum, Oid roleid,
 		ReleaseSysCache(attTuple);
 		return 0;
 	}
-	classForm = (Form_pg_class) GETSTRUCT(classTuple);
+	classForm = GETSTRUCT(pg_class, classTuple);
 
 	ownerId = classForm->relowner;
 
@@ -4072,7 +4072,7 @@ pg_class_aclmask_ext(Oid table_oid, Oid roleid, AclMode mask,
 							table_oid)));
 	}
 
-	classForm = (Form_pg_class) GETSTRUCT(tuple);
+	classForm = GETSTRUCT(pg_class, tuple);
 
 	/*
 	 * Deny anyone permission to update a system catalog unless
@@ -4183,7 +4183,7 @@ pg_database_aclmask(Oid db_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_DATABASE),
 				 errmsg("database with OID %u does not exist", db_oid)));
 
-	ownerId = ((Form_pg_database) GETSTRUCT(tuple))->datdba;
+	ownerId = (GETSTRUCT(pg_database, tuple))->datdba;
 
 	aclDatum = SysCacheGetAttr(DATABASEOID, tuple, Anum_pg_database_datacl,
 							   &isNull);
@@ -4352,7 +4352,7 @@ pg_proc_aclmask(Oid proc_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("function with OID %u does not exist", proc_oid)));
 
-	ownerId = ((Form_pg_proc) GETSTRUCT(tuple))->proowner;
+	ownerId = (GETSTRUCT(pg_proc, tuple))->proowner;
 
 	aclDatum = SysCacheGetAttr(PROCOID, tuple, Anum_pg_proc_proacl,
 							   &isNull);
@@ -4406,7 +4406,7 @@ pg_language_aclmask(Oid lang_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("language with OID %u does not exist", lang_oid)));
 
-	ownerId = ((Form_pg_language) GETSTRUCT(tuple))->lanowner;
+	ownerId = (GETSTRUCT(pg_language, tuple))->lanowner;
 
 	aclDatum = SysCacheGetAttr(LANGOID, tuple, Anum_pg_language_lanacl,
 							   &isNull);
@@ -4485,7 +4485,7 @@ pg_largeobject_aclmask_snapshot(Oid lobj_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("large object %u does not exist", lobj_oid)));
 
-	ownerId = ((Form_pg_largeobject_metadata) GETSTRUCT(tuple))->lomowner;
+	ownerId = (GETSTRUCT(pg_largeobject_metadata, tuple))->lomowner;
 
 	aclDatum = heap_getattr(tuple, Anum_pg_largeobject_metadata_lomacl,
 							RelationGetDescr(pg_lo_meta), &isNull);
@@ -4570,7 +4570,7 @@ pg_namespace_aclmask(Oid nsp_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_SCHEMA),
 				 errmsg("schema with OID %u does not exist", nsp_oid)));
 
-	ownerId = ((Form_pg_namespace) GETSTRUCT(tuple))->nspowner;
+	ownerId = (GETSTRUCT(pg_namespace, tuple))->nspowner;
 
 	aclDatum = SysCacheGetAttr(NAMESPACEOID, tuple, Anum_pg_namespace_nspacl,
 							   &isNull);
@@ -4634,7 +4634,7 @@ pg_tablespace_aclmask(Oid spc_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("tablespace with OID %u does not exist", spc_oid)));
 
-	ownerId = ((Form_pg_tablespace) GETSTRUCT(tuple))->spcowner;
+	ownerId = (GETSTRUCT(pg_tablespace, tuple))->spcowner;
 
 	aclDatum = SysCacheGetAttr(TABLESPACEOID, tuple,
 							   Anum_pg_tablespace_spcacl,
@@ -4693,7 +4693,7 @@ pg_foreign_data_wrapper_aclmask(Oid fdw_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("foreign-data wrapper with OID %u does not exist",
 						fdw_oid)));
-	fdwForm = (Form_pg_foreign_data_wrapper) GETSTRUCT(tuple);
+	fdwForm = GETSTRUCT(pg_foreign_data_wrapper, tuple);
 
 	/*
 	 * Normal case: get the FDW's ACL from pg_foreign_data_wrapper
@@ -4755,7 +4755,7 @@ pg_foreign_server_aclmask(Oid srv_oid, Oid roleid,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("foreign server with OID %u does not exist",
 						srv_oid)));
-	srvForm = (Form_pg_foreign_server) GETSTRUCT(tuple);
+	srvForm = GETSTRUCT(pg_foreign_server, tuple);
 
 	/*
 	 * Normal case: get the foreign server's ACL from pg_foreign_server
@@ -4815,7 +4815,7 @@ pg_type_aclmask(Oid type_oid, Oid roleid, AclMode mask, AclMaskHow how)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("type with OID %u does not exist",
 						type_oid)));
-	typeForm = (Form_pg_type) GETSTRUCT(tuple);
+	typeForm = GETSTRUCT(pg_type, tuple);
 
 	/*
 	 * "True" array types don't manage permissions of their own; consult the
@@ -4831,7 +4831,7 @@ pg_type_aclmask(Oid type_oid, Oid roleid, AclMode mask, AclMaskHow how)
 		/* this case is not a user-facing error, so elog not ereport */
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for type %u", elttype_oid);
-		typeForm = (Form_pg_type) GETSTRUCT(tuple);
+		typeForm = GETSTRUCT(pg_type, tuple);
 	}
 
 	/*
@@ -4936,7 +4936,7 @@ pg_attribute_aclcheck_all(Oid table_oid, Oid roleid, AclMode mode,
 	classTuple = SearchSysCache1(RELOID, ObjectIdGetDatum(table_oid));
 	if (!HeapTupleIsValid(classTuple))
 		return ACLCHECK_NO_PRIV;
-	classForm = (Form_pg_class) GETSTRUCT(classTuple);
+	classForm = GETSTRUCT(pg_class, classTuple);
 
 	nattrs = classForm->relnatts;
 
@@ -4960,7 +4960,7 @@ pg_attribute_aclcheck_all(Oid table_oid, Oid roleid, AclMode mode,
 			continue;
 
 		/* ignore dropped columns */
-		if (((Form_pg_attribute) GETSTRUCT(attTuple))->attisdropped)
+		if ((GETSTRUCT(pg_attribute, attTuple))->attisdropped)
 		{
 			ReleaseSysCache(attTuple);
 			continue;
@@ -5183,7 +5183,7 @@ pg_class_ownercheck(Oid class_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_TABLE),
 				 errmsg("relation with OID %u does not exist", class_oid)));
 
-	ownerId = ((Form_pg_class) GETSTRUCT(tuple))->relowner;
+	ownerId = (GETSTRUCT(pg_class, tuple))->relowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5209,7 +5209,7 @@ pg_type_ownercheck(Oid type_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("type with OID %u does not exist", type_oid)));
 
-	ownerId = ((Form_pg_type) GETSTRUCT(tuple))->typowner;
+	ownerId = (GETSTRUCT(pg_type, tuple))->typowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5235,7 +5235,7 @@ pg_oper_ownercheck(Oid oper_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("operator with OID %u does not exist", oper_oid)));
 
-	ownerId = ((Form_pg_operator) GETSTRUCT(tuple))->oprowner;
+	ownerId = (GETSTRUCT(pg_operator, tuple))->oprowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5261,7 +5261,7 @@ pg_proc_ownercheck(Oid proc_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("function with OID %u does not exist", proc_oid)));
 
-	ownerId = ((Form_pg_proc) GETSTRUCT(tuple))->proowner;
+	ownerId = (GETSTRUCT(pg_proc, tuple))->proowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5287,7 +5287,7 @@ pg_language_ownercheck(Oid lan_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("language with OID %u does not exist", lan_oid)));
 
-	ownerId = ((Form_pg_language) GETSTRUCT(tuple))->lanowner;
+	ownerId = (GETSTRUCT(pg_language, tuple))->lanowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5332,7 +5332,7 @@ pg_largeobject_ownercheck(Oid lobj_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("large object %u does not exist", lobj_oid)));
 
-	ownerId = ((Form_pg_largeobject_metadata) GETSTRUCT(tuple))->lomowner;
+	ownerId = (GETSTRUCT(pg_largeobject_metadata, tuple))->lomowner;
 
 	systable_endscan(scan);
 	table_close(pg_lo_meta, AccessShareLock);
@@ -5359,7 +5359,7 @@ pg_namespace_ownercheck(Oid nsp_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_SCHEMA),
 				 errmsg("schema with OID %u does not exist", nsp_oid)));
 
-	ownerId = ((Form_pg_namespace) GETSTRUCT(tuple))->nspowner;
+	ownerId = (GETSTRUCT(pg_namespace, tuple))->nspowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5386,7 +5386,7 @@ pg_tablespace_ownercheck(Oid spc_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("tablespace with OID %u does not exist", spc_oid)));
 
-	spcowner = ((Form_pg_tablespace) GETSTRUCT(spctuple))->spcowner;
+	spcowner = (GETSTRUCT(pg_tablespace, spctuple))->spcowner;
 
 	ReleaseSysCache(spctuple);
 
@@ -5413,7 +5413,7 @@ pg_opclass_ownercheck(Oid opc_oid, Oid roleid)
 				 errmsg("operator class with OID %u does not exist",
 						opc_oid)));
 
-	ownerId = ((Form_pg_opclass) GETSTRUCT(tuple))->opcowner;
+	ownerId = (GETSTRUCT(pg_opclass, tuple))->opcowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5440,7 +5440,7 @@ pg_opfamily_ownercheck(Oid opf_oid, Oid roleid)
 				 errmsg("operator family with OID %u does not exist",
 						opf_oid)));
 
-	ownerId = ((Form_pg_opfamily) GETSTRUCT(tuple))->opfowner;
+	ownerId = (GETSTRUCT(pg_opfamily, tuple))->opfowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5467,7 +5467,7 @@ pg_ts_dict_ownercheck(Oid dict_oid, Oid roleid)
 				 errmsg("text search dictionary with OID %u does not exist",
 						dict_oid)));
 
-	ownerId = ((Form_pg_ts_dict) GETSTRUCT(tuple))->dictowner;
+	ownerId = (GETSTRUCT(pg_ts_dict, tuple))->dictowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5494,7 +5494,7 @@ pg_ts_config_ownercheck(Oid cfg_oid, Oid roleid)
 				 errmsg("text search configuration with OID %u does not exist",
 						cfg_oid)));
 
-	ownerId = ((Form_pg_ts_config) GETSTRUCT(tuple))->cfgowner;
+	ownerId = (GETSTRUCT(pg_ts_config, tuple))->cfgowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5521,7 +5521,7 @@ pg_foreign_data_wrapper_ownercheck(Oid srv_oid, Oid roleid)
 				 errmsg("foreign-data wrapper with OID %u does not exist",
 						srv_oid)));
 
-	ownerId = ((Form_pg_foreign_data_wrapper) GETSTRUCT(tuple))->fdwowner;
+	ownerId = (GETSTRUCT(pg_foreign_data_wrapper, tuple))->fdwowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5548,7 +5548,7 @@ pg_foreign_server_ownercheck(Oid srv_oid, Oid roleid)
 				 errmsg("foreign server with OID %u does not exist",
 						srv_oid)));
 
-	ownerId = ((Form_pg_foreign_server) GETSTRUCT(tuple))->srvowner;
+	ownerId = (GETSTRUCT(pg_foreign_server, tuple))->srvowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5575,7 +5575,7 @@ pg_event_trigger_ownercheck(Oid et_oid, Oid roleid)
 				 errmsg("event trigger with OID %u does not exist",
 						et_oid)));
 
-	ownerId = ((Form_pg_event_trigger) GETSTRUCT(tuple))->evtowner;
+	ownerId = (GETSTRUCT(pg_event_trigger, tuple))->evtowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5601,7 +5601,7 @@ pg_database_ownercheck(Oid db_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_DATABASE),
 				 errmsg("database with OID %u does not exist", db_oid)));
 
-	dba = ((Form_pg_database) GETSTRUCT(tuple))->datdba;
+	dba = (GETSTRUCT(pg_database, tuple))->datdba;
 
 	ReleaseSysCache(tuple);
 
@@ -5627,7 +5627,7 @@ pg_collation_ownercheck(Oid coll_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("collation with OID %u does not exist", coll_oid)));
 
-	ownerId = ((Form_pg_collation) GETSTRUCT(tuple))->collowner;
+	ownerId = (GETSTRUCT(pg_collation, tuple))->collowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5653,7 +5653,7 @@ pg_conversion_ownercheck(Oid conv_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("conversion with OID %u does not exist", conv_oid)));
 
-	ownerId = ((Form_pg_conversion) GETSTRUCT(tuple))->conowner;
+	ownerId = (GETSTRUCT(pg_conversion, tuple))->conowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5694,7 +5694,7 @@ pg_extension_ownercheck(Oid ext_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("extension with OID %u does not exist", ext_oid)));
 
-	ownerId = ((Form_pg_extension) GETSTRUCT(tuple))->extowner;
+	ownerId = (GETSTRUCT(pg_extension, tuple))->extowner;
 
 	systable_endscan(scan);
 	table_close(pg_extension, AccessShareLock);
@@ -5721,7 +5721,7 @@ pg_publication_ownercheck(Oid pub_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("publication with OID %u does not exist", pub_oid)));
 
-	ownerId = ((Form_pg_publication) GETSTRUCT(tuple))->pubowner;
+	ownerId = (GETSTRUCT(pg_publication, tuple))->pubowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5747,7 +5747,7 @@ pg_subscription_ownercheck(Oid sub_oid, Oid roleid)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("subscription with OID %u does not exist", sub_oid)));
 
-	ownerId = ((Form_pg_subscription) GETSTRUCT(tuple))->subowner;
+	ownerId = (GETSTRUCT(pg_subscription, tuple))->subowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5774,7 +5774,7 @@ pg_statistics_object_ownercheck(Oid stat_oid, Oid roleid)
 				 errmsg("statistics object with OID %u does not exist",
 						stat_oid)));
 
-	ownerId = ((Form_pg_statistic_ext) GETSTRUCT(tuple))->stxowner;
+	ownerId = (GETSTRUCT(pg_statistic_ext, tuple))->stxowner;
 
 	ReleaseSysCache(tuple);
 
@@ -5805,7 +5805,7 @@ has_createrole_privilege(Oid roleid)
 	utup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(roleid));
 	if (HeapTupleIsValid(utup))
 	{
-		result = ((Form_pg_authid) GETSTRUCT(utup))->rolcreaterole;
+		result = (GETSTRUCT(pg_authid, utup))->rolcreaterole;
 		ReleaseSysCache(utup);
 	}
 	return result;
@@ -5824,7 +5824,7 @@ has_bypassrls_privilege(Oid roleid)
 	utup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(roleid));
 	if (HeapTupleIsValid(utup))
 	{
-		result = ((Form_pg_authid) GETSTRUCT(utup))->rolbypassrls;
+		result = (GETSTRUCT(pg_authid, utup))->rolbypassrls;
 		ReleaseSysCache(utup);
 	}
 	return result;
@@ -5996,7 +5996,7 @@ recordExtObjInitPriv(Oid objoid, Oid classoid)
 		tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(objoid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for relation %u", objoid);
-		pg_class_tuple = (Form_pg_class) GETSTRUCT(tuple);
+		pg_class_tuple = GETSTRUCT(pg_class, tuple);
 
 		/*
 		 * Indexes don't have permissions, neither do the pg_class rows for
@@ -6033,7 +6033,7 @@ recordExtObjInitPriv(Oid objoid, Oid classoid)
 					continue;
 
 				/* ignore dropped columns */
-				if (((Form_pg_attribute) GETSTRUCT(attTuple))->attisdropped)
+				if ((GETSTRUCT(pg_attribute, attTuple))->attisdropped)
 				{
 					ReleaseSysCache(attTuple);
 					continue;
@@ -6290,7 +6290,7 @@ removeExtObjInitPriv(Oid objoid, Oid classoid)
 		tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(objoid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for relation %u", objoid);
-		pg_class_tuple = (Form_pg_class) GETSTRUCT(tuple);
+		pg_class_tuple = GETSTRUCT(pg_class, tuple);
 
 		/*
 		 * Indexes don't have permissions, neither do the pg_class rows for
diff --git a/src/backend/catalog/catalog.c b/src/backend/catalog/catalog.c
index 6f43870779..31e06aab3e 100644
--- a/src/backend/catalog/catalog.c
+++ b/src/backend/catalog/catalog.c
@@ -629,7 +629,7 @@ pg_nextoid(PG_FUNCTION_ARGS)
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						NameStr(*attname), RelationGetRelationName(rel))));
 
-	attform = ((Form_pg_attribute) GETSTRUCT(atttuple));
+	attform = (GETSTRUCT(pg_attribute, atttuple));
 	attno = attform->attnum;
 
 	if (attform->atttypid != OIDOID)
diff --git a/src/backend/catalog/dependency.c b/src/backend/catalog/dependency.c
index de10923391..4c96444617 100644
--- a/src/backend/catalog/dependency.c
+++ b/src/backend/catalog/dependency.c
@@ -577,7 +577,7 @@ findDependentObjects(const ObjectAddress *object,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend foundDep = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend foundDep = GETSTRUCT(pg_depend, tup);
 
 		otherObject.classId = foundDep->refclassid;
 		otherObject.objectId = foundDep->refobjid;
@@ -866,7 +866,7 @@ findDependentObjects(const ObjectAddress *object,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend foundDep = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend foundDep = GETSTRUCT(pg_depend, tup);
 		int			subflags;
 
 		otherObject.classId = foundDep->classid;
